<?php
# Modul: wkabwickeln_dms
/*
Wettkampfabwicklung, Aktion: dms_startkarten
verwendete Templates:
 - 42.dms-startkarten.inc.html
*/
$_select = array(
	'sort' => array(
		'gestapelt'   => 'gestapelt',
		'fortlaufend' => 'fortlaufend'
	),
	'blanko' => array(
		1  => '1 Karte',
		4  => '4 Karten',
		7  => '7 Karten',
		10 => '10 Karten',
		13 => '13 Karten'
	),
	'laeufe' => array(
		'r1' => 'rotierend, Beginn in Lauf 1',
		'r2' => 'rotierend, Beginn in Lauf 2',
		'r3' => 'rotierend, Beginn in Lauf 3',
		's1' => 'statisch, in Lauf 1',
		's2' => 'statisch, in Lauf 2',
		's3' => 'statisch, in Lauf 3'
	),
	'1bahn' => array(
		'1' => 'Bahn 1',
		'2' => 'Bahn 2',
		'3' => 'Bahn 3',
		'4' => 'Bahn 4',
		'5' => 'Bahn 5',
		'6' => 'Bahn 6',
		'7' => 'Bahn 7',
		'8' => 'Bahn 8',
		'9' => 'Bahn 9',
		'10' => 'Bahn 10'
	),
	'zusammenlegung' => array(
		'400'  => '400F',
		'800'  => '800F',
		'1500' => '1500F'
	),
	'zusammenlauf1' => array(
		'r' => 'Lauf 1 schwimmt rechts',
		'l' => 'Lauf 1 schwimmt links'
	)
);

$_conf = array(
	'allg' => array(
		'sort'   => 'gestapelt',
		'blanko' => 4,
		'namen'  => 1,
		'keinebahnen' => 1
	),
	'bv' => array(
		'bahnen' => 6,
		'zusammenlegung' => array(400,800,1500),
		'zusammenlauf1' => 'r',
		'_mannschaften' => array(),
		'_mannschaft' => array(
			'laeufe' => 's1',
			'1bahn' => '3'
		)
	)
);

$_select['mannschaften'] = array();
foreach($_wkeinst['dms'] as $mannschaft => $schwimmer){
	$_select['mannschaften'][$mannschaft] = $mannschaft[1].'. Mannschaft '.$_geschlechter[$mannschaft[0]];
}
$_conf['allg']['mannschaften'] = array_keys($_select['mannschaften']);

if(!isset($_POST['pdferzeugen'])){
	if(isset($_wkeinst['wettkampfdaten']['startkarten'])){
		$conf = json_decode(str_replace("'",'"',$_wkeinst['wettkampfdaten']['startkarten']), true);
	}
	else{
		$conf = $_conf;
		unset($conf['bv']['_mannschaft']);
		$conf['allg']['mannschaften'] = array_keys($_select['mannschaften']);
	}
	foreach($_select['mannschaften'] as $mkey => $mannschaft){
		if(isset($conf['bv']['_mannschaften'][$mkey])){
			continue;
		}
		$conf['bv']['_mannschaften'][$mkey] = $_conf['bv']['_mannschaft'];
	}
	
	$_tmpl->assign('select', $_select);
	$_tmpl->assign('conf', $conf);
	$_tmpl->assign('flags', $flags);
	
	$_inh .= $_tmpl->fetch('wettkaempfe/42.dms-startkarten.inc.html');
}
else{
	if(!isset($_POST['conf']['allg']['mannschaften'])){
		$mannschaften = array_keys($_wkeinst['dms']);
	}
	else{
		$mannschaften = array();
		foreach($_POST['conf']['allg']['mannschaften'] as $m){
			if(!array_key_exists($m, $_wkeinst['dms'])){
				continue;
			}
			$mannschaften[] = $m;
		}
		if(count($mannschaften)<1){
			$mannschaften = array_keys($_wkeinst['dms']);
		}
	}
	$conf = $_POST['conf'];
	$conf['sort'] = (isset($conf['sort']) and array_key_exists($conf['sort'], $_select['sort']))?$conf['sort']:$_conf['allg']['sort'];
	$conf['blanko'] = (isset($conf['blanko']) and array_key_exists($conf['blanko'], $_select['blanko']))?$conf['blanko']:$_conf['allg']['blanko'];
	$conf['bahnen'] = !isset($_POST['conf']['allg']['keinebahnen']);
	# Conf speichern
	$einstellungen = str_replace('"',"'",json_encode($conf));
	$_wkeinst['wettkampfdaten']['startkarten'] = $einstellungen;
	require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
	schreibe_ini_datei(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'], $_wkeinst, true);

	require_once(PFAD_INCLUDE.'class/tkpdf.inc.php');
	$pdf = new tkpdf();
	$dmsreihenfolge = require(PFAD_INCLUDE.'conf/dms-wettkampffolge.inc.php');

	$karten = array();
	$_namen = false;
	if(isset($_POST['conf']['allg']['namen']) and $flags['dms_streckenzuordnung']){
		$namen = $mids = array();
		$_namen = true;
		foreach($mannschaften as $mannschaft){
			if(!isset($_wkeinst['dmsstreckenzuordnung'][$mannschaft])){
				continue;
			}
			$namen[$mannschaft] = json_decode(str_replace("'",'"',$_wkeinst['dmsstreckenzuordnung'][$mannschaft]), true);
			if(!empty($_wkeinst['dms'][$mannschaft])){
				$mids = array_merge($mids, explode('|', $_wkeinst['dms'][$mannschaft]));
			}
		}
		if(count($mids)>0){
			$query = "SELECT id, CONCAT(vorname, ' ', nachname) as name, YEAR(gebdatum) as jg, '' as meldezeit FROM ".DB_PREFIX."mitglieder
						WHERE id IN (".implode(',',$mids).")";
			$_db->holeDaten($query);
			$ms = $_db->baueArray('*', 'id');
			foreach($namen as $mannschaft => $mdat){
				foreach($mdat as $abschn => $adat){
					foreach($adat as $disziplin => $ddat){
						foreach($ddat as $laenge => $mid){
							$name = array_key_exists($mid, $ms)?$ms[$mid]:'';
							$namen[$mannschaft][$abschn][$disziplin][$laenge] = $name;
						}
					}
				}
			}
		}
	}

	foreach($mannschaften as $mannschaft){
		$nr = 1;
		$bahn = array(
			'a1' => $conf['bv']['_mannschaften'][$mannschaft]['1bahn'],
			'a2' => 2
			#'a2' => $conf['bv']['_mannschaften'][$mannschaft]['1bahn']+(13%$conf['bv']['bahnen'])
		);
		if($bahn['a2']>$conf['bv']['bahnen']){
			$bahn['a2'] -= $conf['bv']['bahnen'];
		}
		$l = $conf['bv']['_mannschaften'][$mannschaft]['laeufe'][1];
		$lauf = array(
			'a1' => $l,
			'a2' => $bahn['a1']<=2?$l:($l==1?2:1)
		);

		$karten_1 = $karten_2 = array();
		$bezeichnung = $mannschaft[1].'. Mannschaft '.$_geschlechter[$mannschaft[0]];
		$mw = $mannschaft[0];
		foreach($dmsreihenfolge as $wk){
			$name = array(
				1 => array('name'=>'','jg'=>'','meldezeit'=>''),
				2 => array('name'=>'','jg'=>'','meldezeit'=>'')
			);
			$wk['laenge'] = ($wk['laenge']=='1500' and $mw=='w')?'800':$wk['laenge'];

			if($_namen){
				if(isset($namen[$mannschaft]) and isset($namen[$mannschaft][1][$wk['lage']][$wk['laenge']]) and is_array($namen[$mannschaft][1][$wk['lage']][$wk['laenge']])){
					$name[1] = $namen[$mannschaft][1][$wk['lage']][$wk['laenge']];

				}
				if(isset($namen[$mannschaft]) and isset($namen[$mannschaft][2][$wk['lage']][$wk['laenge']]) and is_array($namen[$mannschaft][2][$wk['lage']][$wk['laenge']])){
					$name[2] = $namen[$mannschaft][2][$wk['lage']][$wk['laenge']];
				}
			}
			
			$zusammenlegung = (in_array($wk['laenge'],$conf['bv']['zusammenlegung']) and $wk['lage']==1);
			#$lauf = $conf['bv']['_mannschaften'][$mannschaft]['laeufe'][1];

			$karten_1[] = array(
				'wknr'   => $nr+($mw=='w'?0:1),
				'wkname' => $wk['laenge'].' '.$_lagen[$wk['lage']].' '.$_geschlechter[$mw],
				'name'   => $name[1]['name'],
				'verein' => TKSWIM_VEREIN.' ('.$bezeichnung.')',
				'jg'     => $name[1]['jg'],
				'lauf'   => ($conf['bahnen']?($zusammenlegung?'1 '.(($conf['bv']['zusammenlauf1']=='r' and $lauf['a1']==2)?'links':'rechts'):$lauf['a1']):''),
				'bahn'   => ($conf['bahnen']?$bahn['a1']:'')
			);
			$karten_2[] = array(
				'wknr'   => $nr+26+($mw=='w'?0:1),
				'wkname' => $wk['laenge'].' '.$_lagen[$wk['lage']].' '.$_geschlechter[$mw],
				'name'   => $name[2]['name'],
				'verein' => TKSWIM_VEREIN.' ('.$bezeichnung.')',
				'jg'     => $name[2]['jg'],
				#'lauf'   => $zusammenlegung?'1 '.($conf['bv']['zusammenlauf1']=='r'?'links':'rechts'):$lauf,
				'lauf'   => ($conf['bahnen']?($zusammenlegung?'1 '.(($conf['bv']['zusammenlauf1']=='r' and $lauf['a2']==2)?'links':'rechts'):$lauf['a2']):''),
				'bahn'   => ($conf['bahnen']?$bahn['a2']:'')
			);
			$nr += 2;
			$bahn['a1']++;
			$bahn['a2']++;
			if($bahn['a1'] > $conf['bv']['bahnen']){
				$bahn['a1'] = 1;
				$lauf['a1'] = $lauf['a1']==1?2:1;
			}
			if($bahn['a2'] > $conf['bv']['bahnen']){
				$bahn['a2'] = 1;
				$lauf['a2'] = $lauf['a2']==1?2:1;
			}
		}
		$karten = array_merge($karten, $karten_1);
		$karten = array_merge($karten, $karten_2);
		for($i=1;$i<=$conf['allg']['blanko'];$i++){
			$karten[] = array(
				'wknr'   => '',
				'wkname' => '',
				'name'   => '',
				'verein' => TKSWIM_VEREIN,
				'jg'     => '',
				'lauf'   => '',
				'bahn'   => ''
			);
		}
	}
	
	$pdf->erzeugeStartkarten($karten, $conf);
	$pdf->setzeTitel('Startkarten');
	$pdf->ausgabe();
}
# EOF
