<?php
$_db->speichereGeaenderteTabellen();

# Navigation
require_once(PFAD_INCLUDE.'func/navigation.inc.php');
$nav = navigation($_seite);
$_tmpl->assign('navigation',$nav);
if(isset($_tmpl->tk_fussnoten) and count($_tmpl->tk_fussnoten) > 0){
	$_tmpl->assign('fussnoten',$_tmpl->tk_fussnoten);
}

# Loginformular
$login = false;
if(!isset($_SESSION['eingelogt']) or $_SESSION['eingelogt']=='auto'){
	if(($_seite=='admin' and PFAD_HTTP=='') or !is_dir(PFAD_HTTP) or !defined('TKSWIM_DATEIENDUNG')){
		$url = '/admin.php';
	}
	else{
		$url = '/login'.(version_compare(TKSWIM_VERSION, '0.10.0', '<')?'.php':TKSWIM_DATEIENDUNG);
		if(strpos($_SERVER['SCRIPT_NAME'],'login.php') === false){
			$ps = $_SERVER['SCRIPT_NAME']=='/index.php'?'':$_SERVER['SCRIPT_NAME'];
			if(TKSWIM_DATEIENDUNG=='.html' and substr($ps,-4)=='.php'){
				$ps = substr($ps,0,-4).TKSWIM_DATEIENDUNG;
			}
			$_SESSION['vonseite'] = $ps.(!empty($_SERVER['QUERY_STRING'])?'?'.$_SERVER['QUERY_STRING']:'');
		}
	}
	$login = [
		'url' => $url,
		'fehler' => false
	];
	if(!empty($_SESSION['fehler'])){
		$login['fehler'] = $_SESSION['fehler'];
		unset($_SESSION['fehler']);
	}
}
$_tmpl->assign('login',$login);
$_tmpl->assign('inhalt',$_inh);

if(isset($_SESSION['eingelogt']) and $_SESSION['eingelogt']=='auto'){
	$_tmpl->tk_javascriptzuweisen('onready', "$('form#login h2').click(function(){ $('form#login').toggleClass('verstecken'); });");
	$_tmpl->tk_javascriptzuweisen('onready', "$('form#login input').change(function(){ $('form#login').removeClass('verstecken'); });");
	if(!empty($nav) and !isset($_SESSION['ersteraufruf']) and $url != $_SERVER['REQUEST_URI']){
		$_tmpl->tk_javascriptzuweisen('onready', "$('form#login').addClass('verstecken');");
	}
	elseif(isset($_SESSION['ersteraufruf'])){
		unset($_SESSION['ersteraufruf']);
	}
}
$_tmpl->tk_javascriptzuweisen('onready', "$('header p#nav').tkswim_navigation('oeffnen');");
$_tmpl->tk_javascriptzuweisen('onready', "$('nav p#schliessen').tkswim_navigation('schliessen');");
$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.tkswim');

# Hinweise
if(isset($_SESSION['hinweis'])){
	$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message');
	$_tmpl->tk_javascriptzuweisen('onready',"$().message('".text_format($_SESSION['hinweis'],'js')."');");
}

# Javascript zuweisen
$_tmpl->tk_javascriptvorbereiten();

# Hintergrundbild und Favicon vorhanden?
if(isset($_SESSION['darstellung'])){
	if($_SESSION['darstellung']['hintergrund']){
		if(is_null($_tmpl->get_template_vars('css_inline'))){
			$_tmpl->assign('css_inline', []);
		}
		$_tmpl->append('css_inline',"body { background:url('".ROOT."/src/img/hintergrund.png') repeat-y 6em 1em; }");
	}
	$_tmpl->assign('faviconanzeigen', $_SESSION['darstellung']['favicon']);
}

# css_inline ggf. um Leerzeile kürzen
if(!is_null($_tmpl->get_template_vars('css_inline'))){
	$_tmpl->assign('css_inline', implode("\n", $_tmpl->get_template_vars('css_inline')));
}
# externe CSS-Datei
if(!empty($_einst['globaleeinstellungen']['externecssdatei'])){
	$_tmpl->assign('externecssdatei',$_einst['globaleeinstellungen']['externecssdatei']);
}

$inhalt = $_tmpl->fetch('tmpl.inc.html');
if(!headers_sent()){
	header('x-Powered-By: tkswim');
	header('Content-Type: text/html; charset=utf-8');
}
if(isset($_einst) and $_einst['globaleeinstellungen']['inhaltkomprimiertausliefern']){
	ob_start('ob_gzhandler');
	echo $inhalt;
	ob_end_flush();
}
else{
	echo $inhalt;
}

if(isset($_SESSION['hinweis'])){
	unset($_SESSION['hinweis']);
}
# EOF
