<?php
# Modul: wkabwickeln_dms
/*
Wettkampfabwicklung, Aktion: dms_meldeformular
verwendete Templates:
 - [keines]
*/
require_once(PFAD_INCLUDE.'class/ooodateien.inc.php');
$ooo = new ooodateien($_tmpl,'dmsmeldebogen');
# Mannschaftsdaten
$daten = array();
foreach($_wkeinst['dms'] as $key => $mitgl){
	if(empty($mitgl)){ # für diese Mannschaft sind keine Mitglieder gesetzt
		#continue;
	}
	$tmp = [];
	$tmp['mwx'] = $key[0];
	$tmp['mitglieder'] = [];
	if(!empty($mitgl)){
		$query = "SELECT id as nr, nachname, vorname, YEAR(gebdatum) as jg, dsvid FROM ".DB_PREFIX."mitglieder
					WHERE id IN (".str_replace('|',',',$mitgl).") ORDER BY nachname, vorname";
		$_db->holeDaten($query);
		$tmp['mitglieder'] = $_db->baueArray('*','#');
	}
	for($i=1;$i<=11;$i++){
		if(!isset($tmp['mitglieder'][$i-1])){
			$tmp['mitglieder'][$i-1] = array(
				'nr'       => $i,
				'nachname' => '',
				'vorname'  => '',
				'jg'       => '',
				'dsvid'    => ''
			);
			continue;
		}
		$tmp['mitglieder'][$i-1]['nr'] = $i;
	}
	$daten[] = $tmp;
}

# Ansprechpartner
$query = "SELECT mitgliedid FROM ".DB_PREFIX."vorstand WHERE id = ".$_wkeinst['meldedatei']['ansprechpartner'];
$_db->holeDaten($query);
$mid = $_db->holeWert();
$query = "SELECT CONCAT(vorname,' ',nachname) as name, email, 
				CONCAT(strasse,' ',hausnr) as strasse, CONCAT(plz,' ',ort) as ort, '' as tel
			FROM ".DB_PREFIX."mitglieder WHERE id = ".$mid;
$_db->holeDaten($query);
$ansprechpartner = $_db->holeZeile();
$query = "SELECT CONCAT(vorwahl,'/',nummer) as tel FROM ".DB_PREFIX."telefon WHERE mitgliedid = ".$mid." AND telefonart = 1 ORDER BY tel";
$_db->holeDaten($query);
if($_db->holeAnzahl() != 0){
	$ansprechpartner['tel'] = $_db->holeWert();
}
# Metadaten
$_meta = array(
	'generator' => 'tkswim '.TKSWIM_VERSION,
	'titel'     => 'DMS-Meldebogen (DSV-Form 105)',
	'creator'   => $_SESSION['user']['realname'],
	'date'      => date('Y-m-d\TH:i:s')
);
# Vereinsdaten
$verein = array(
	'name'  => TKSWIM_VEREIN,
	'id'    => TKSWIM_VEREINSID,
	'lsvnr' => TKSWIM_LSVKENNZIFFER
);
# Wettkampfdaten
$wkdat = array(
	'liga'  => text_format($_wkeinst['meldedatei']['dmsliga'],'htmlmaskieren'),
	'wettbewerb' => $_wkeinst['meldedatei']['dmsliga'],
	'datum' => '',
	'ort'   => ''
);
$query = "SELECT DATE_FORMAT(datum,'%d') as tag, DATE_FORMAT(datum,'%d.%m.%Y') as ausgdatum FROM ".DB_PREFIX."abschnitte
			WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']." GROUP BY datum ORDER BY datum ASC";
$_db->holeDaten($query);
$termine = $_db->baueArray('*','#');
if($_db->holeAnzahl() == 0){
	$wkdat['datum'] = $_wkeinst['wettkampfdaten']['datum'];
}
elseif($_db->holeAnzahl() == 1){
	$wkdat['datum'] = $termine[0]['ausgdatum'];
}
elseif($_db->holeAnzahl() == 2){
	$wkdat['datum'] = $termine[0]['tag'].'./'.$termine[1]['ausgdatum'];
}
else{
	$wkdat['datum'] = $termine[0]['tag'].'.-'.$termine[$_db->holeAnzahl()-1]['ausgdatum'];
}
$query = "SELECT ort FROM ".DB_PREFIX."wettkaempfe WHERE id = ".$_SESSION['wk_abwickeln']['id'];
$_db->holeDaten($query);
$wkdat['ort'] = $_wkeinst['wettkampfdaten']['ort'];

# Daten an Klasse uebergeben
$ooo->setzeWerte('daten',$daten);
$ooo->setzeWerte('_meta',$_meta);
$ooo->setzeWerte('ansprechpartner',$ansprechpartner);
$ooo->setzeWerte('verein',$verein);
$ooo->setzeWerte('wk',$wkdat);
$ooo->setzeEinstellung('ooo:configuration-settings','AddParaTableSpacingAtStart','boolean',true);
# Datei generieren
$ooo->generiereDateien();
$ooo->setzeDateiname('dmsmeldebogen.odt');
$ooo->gebeOooDateiAus();
# EOF
