<?php
# Modul: wkabwickeln_dms
/*
Wettkampfabwicklung, Aktion: dms_mannschaften
verwendete Templates:
 - 42.dms-streckenschwimmerzuordnen.inc.html
*/
$mannschaften = array();
foreach($_wkeinst['dms'] as $key => $schwimmer){
	$mannschaften[$key] = array(
		'mw' => $key[0],
		'nr' => $key[1],
		'titel' => $key[1].'. Mannschaft '.$_geschlechter[$key[0]],
		'schwimmer' => empty($schwimmer)?false:explode('|', $schwimmer)
	);
}

$select = array();
foreach($mannschaften as $key => $row){
	$select[$key] = $row['titel'];
}
$_tmpl->assign('mannschaften', $select);
$_m = false;
$_sort = 'wknr';

if(isset($_POST['mannschaft']) and array_key_exists($_POST['mannschaft'], $mannschaften)){
	$_m = $_POST['mannschaft'];
	$_sort = $_POST['sort'];
	$_mw = $_m[0];
	$_strecken = require(PFAD_INCLUDE.'conf/dms-wettkampffolge.inc.php');

	if($_sort == 'strecke'){
		function sortiereStrecken($a, $b){
			if($a['lage'] == $b['lage']){
				if($a['laenge'] == $b['laenge']){
					return 0;
				}
				else{
					return $a['laenge']>$b['laenge'];
				}
			}
			else{
				return $a['lage']>$b['lage'];
			}
		}

		uasort($_strecken, 'sortiereStrecken');
	}
	$_tmpl->assign('_strecken', $_strecken);
	$_tmpl->assign('_lagen', $_lagen);
	$_tmpl->assign('abschnitte', [1,2]);
	$_tmpl->assign('wknrplus', $_m[0]=='w'?1:2);
	# Schwimmer holen
	$schwimmer = $zehnjaehrige = [];
	if(is_array($mannschaften[$_m]['schwimmer'])){
		$query = "SELECT id, CONCAT(nachname, ', ', vorname, ' (', YEAR(gebdatum), ')') as name
					FROM ".DB_PREFIX."mitglieder
					WHERE id IN (".implode(',', $mannschaften[$_m]['schwimmer']).")
					ORDER BY nachname, vorname";
		$_db->holeDaten($query);
		$schwimmer = $_db->baueArray('name', 'id');
		# die zehnjährigen holen (die dürfen die 800/1500F, 200S und 400L nicht schwimmen)
		$query = "SELECT id	FROM ".DB_PREFIX."mitglieder
					WHERE id IN (".implode(',', $mannschaften[$_m]['schwimmer']).") AND 
						YEAR('".$_SESSION['wk_abwickeln']['wettkampfdatum']."')-YEAR(gebdatum) = 10";
		$_db->holeDaten($query);
		$zehnjaehrige = $_db->baueArray('id', '#');
	}
	$_tmpl->assign('schwimmer', $schwimmer);
	$_tmpl->assign('jzehnjaehrige', $zehnjaehrige);

	# schon gespeicherte Strecken holen
	$strecken = array();
	if(isset($_wkeinst['dmsstreckenzuordnung']) and isset($_wkeinst['dmsstreckenzuordnung'][$_m])){
		$strecken = json_decode(str_replace("'",'"',$_wkeinst['dmsstreckenzuordnung'][$_m]), true);
	}

	if(isset($_POST['speichern'])){
		$mitgliederstarts = array(
			'anzahl' => array(),
			'strecken' => array()
		);
		$f = '';
		foreach($_POST['strecken'] as $abschn => $adat){
			foreach($adat as $disziplin => $ddat){
				foreach($ddat as $laenge => $mid){
					if($mid == '-'){
						continue;
					}
					if(!array_key_exists($mid, $schwimmer)){
						$_POST['strecken'][$abschn][$disziplin][$laenge] = '';
						continue;
					}
					if((($disziplin==1 and in_array($laenge,array(800,1500))) or ($disziplin==4 and $laenge==200) or ($disziplin==5 and $laenge==400)) and in_array($mid, $zehnjaehrige)){
						$f .= 'Zehnjährige dürfen über die Strecken 800/1500F, 200S und 400L nicht starten<br />';
					}
					if(!isset($mitgliederstarts['anzahl'][$mid])){
						$mitgliederstarts['anzahl'][$mid] = 1;
					}
					else{
						$mitgliederstarts['anzahl'][$mid]++;
					}
					if(!isset($mitgliederstarts['strecken'][$disziplin.'_'.$laenge])){
						$mitgliederstarts['strecken'][$disziplin.'_'.$laenge] = $mid;
					}
					else{
						if($mitgliederstarts['strecken'][$disziplin.'_'.$laenge] == $mid){
							$f .= 'Eine Strecke darf von jedem Mitglied nur einmal geschwommen werden ('.$laenge.'m '.$_lagen[$disziplin].')<br />';
						}
					}
				}
			}
		}
		foreach($mitgliederstarts['anzahl'] as $mid => $anz){
			if($anz <= 5){
				continue;
			}
			$f .= 'Jeder Schwimmer darf nur max. 5mal starten ('.text_format($schwimmer[$mid],'html').')<br />';
		}

		if(empty($f)){
			$streckenstr = str_replace('"',"'",json_encode($_POST['strecken']));
			if(!isset($_wkeinst['dmsstreckenzuordnung'])){
				$_wkeinst['dmsstreckenzuordnung'] = array();
			}
			$_wkeinst['dmsstreckenzuordnung'][$_m] = $streckenstr;
			require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
			schreibe_ini_datei(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'], $_wkeinst, true);
			$_SESSION['hinweis'] = 'Die Änderungen wurden gespeichert';
		}
		else{
			$_tmpl->assign('fehler', $f);

		}
		$strecken = $_POST['strecken'];
	}
	$_tmpl->assign('strecken', $strecken);
}

$_sortierennach = array(
	'wknr' => 'Wettkampfnummer',
	'strecke' => 'Strecke/Streckenlänge'
);
$_tmpl->assign('sortierennach', $_sortierennach);
$_tmpl->assign('sort', $_sort);
$_tmpl->assign('m', $_m);
$_inh .= $_tmpl->fetch('wettkaempfe/42.dms-streckenschwimmerzuordnen.inc.html');
# EOF
